/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: itron.h 49 2012-09-06 04:41:53Z ertl-hiro $
 */

/*
 *		ITRONͶ̵Υǡޥ
 *
 *  ΥإåեϡITRONͶ̵Υǡޥ
 *  ǡTOPPERS̥إåե˴ޤޤʤΤޤࡥITRON
 *  ͤȤθߴɬפȤ륢ץꥱ󤬥󥯥롼ɤ뤳Ȥ
 *  ꤷƤ롥
 *
 *  ֥Υե뤫餳Υե򥤥󥯥롼ɤ
 *  ϡTOPPERS_MACRO_ONLYƤˤꡤޥʳ
 *  褦ˤʤäƤ롥
 */

#ifndef TOPPERS_ITRON_H
#define TOPPERS_ITRON_H

#ifdef __cplusplus
extern "C" {
#endif

/*
 *  TOPPERS̥إåե
 */
#include "t_stddef.h"

/*
 *  ITRONͶ̥ǡ
 */
#ifndef TOPPERS_MACRO_ONLY

#ifdef INT8_MAX
typedef	int8_t			B;			/* դ8ӥå */
#endif /* INT8_MAX */

#ifdef UINT8_MAX
typedef	uint8_t			UB;			/* ̵8ӥå */
typedef	uint8_t			VB;			/* ޤʤ8ӥåȤ */
#endif /* UINT8_MAX */

typedef	int16_t			H;			/* դ16ӥå */
typedef	uint16_t		UH;			/* ̵16ӥå */
typedef	uint16_t		VH;			/* ޤʤ16ӥåȤ */

typedef	int32_t			W;			/* դ32ӥå */
typedef	uint32_t		UW;			/* ̵32ӥå */
typedef	uint32_t		VW;			/* ޤʤ32ӥåȤ */

#ifdef INT64_MAX
typedef	int64_t			D;			/* դ64ӥå */
#endif /* INT64_MAX */

#ifdef UINT64_MAX
typedef	uint64_t		UD;			/* ̵64ӥå */
typedef	uint64_t		VD;			/* ޤʤ64ӥåȤ */
#endif /* UINT64_MAX */

typedef	void			*VP;		/* ޤʤΤؤΥݥ */

typedef int_t			INT;		/* ʥդ */
typedef uint_t			UINT;		/* ʥ̵ */

typedef bool_t			BOOL;		/*  */

typedef	intptr_t		VP_INT;		/* ݥ󥿤ޤդ */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ITRONͶ
 */
#define	TRUE		true			/*  */
#define	FALSE		false			/*  */

/*
 *  ֥°
 */
#define TA_HLNG			UINT_C(0x00)	/* ѥ󥿥ե */
#define TA_TFIFO		UINT_C(0x00)	/* ԤFIFO */
#define TA_MFIFO		UINT_C(0x00)	/* å塼FIFO */
#define TA_WSGL			UINT_C(0x00)	/* Ԥ1ĤΤ */

/*
 *  ͥȲκ
 */
#define TMAX_SUSCNT		UINT_C(1)		/* Ԥ׵ͥȿκ */

/*
 *  Ԥ֤ζƳ
 */
#define frsm_tsk(tskid)		rsm_tsk(tskid)

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_ITRON_H */
